///////////////////////////////////////////////////////////////////////////////
//
// main.cpp
//
// Main de base pour VR Juggler. Les fichiers de configuration de VR
// Juggler sont passes par la ligne de commande.
//
// Editeur de roller coaster
// Projet de realite virtuelle (INF6802)
// Herve Lombaert et Yves Chouinard
// Automne 2005
//
///////////////////////////////////////////////////////////////////////////////


#include <vrj/Kernel/Kernel.h>
#include "rc.h"


int main(int argc, char *argv[])
{
	try
	{
		vrj::Kernel * kernel = vrj::Kernel::instance ();
		RC rc (kernel);

		if (argc <= 1)
		{
			std::cout << "Usage: " << argv[0] << " vjconfigfile[0] vjconfigfile[1] ... vjconfigfile[n]" << std::endl;
			exit (1);
		}

		for (int i = 1; i < argc; i++) kernel->loadConfigFile(argv[i]);

		kernel->start ();
		kernel->setApplication (&rc);
		kernel->waitForKernelStop ();

		return 0;
	}
	catch (Path::Exception & e)
	{
		e.what ();
	}
	catch (...)
	{
		printf ("Unknown error in main()\n");
	}

	return 1;
}
