/**
 * @file speed.h
 * @author Herve Lombaert
 * @date October 23rd, 2005
 *
 * Given a path, it determines the speed on this path
 **/

#ifndef SPEED_H
#define SPEED_H

class Path;

class Speed
{
public:
	/** @brief constructor **/
	Speed(const Path* path);

	/** @brief gives the speed on a position on path **/
	double getSpeed(float distance) const;

	/** @brief initialize parameters **/
	void initialize();

private:
	/** @brief speed **/
	inline double speed2(float h) const;

private:
	const Path*	mPath;
	float	mSetDistance;	/** acceleration zone **/
	float	mUnsetDistance;	/** decelleration zone **/
	float	mMaxHeight;	/** maximum height on path **/
	double	mV0;		/** initial speed (at first fall) **/
	double	mV1;		/** final speed in the right **/
};

#endif
