////////////////////////////////////////////////////////////////////////////////
//
// train.h
// Declaration des classes Train et Wagon
//
// Editeur de roller coaster
// Projet de realite virtuelle (INF6802)
// Herve Lombaert et Yves Chouinard
// Automne 2005
//
// Un train est compose de wagons et suit le parcours du roller coaster.
// Le train est cree par init(), qui retourne un noeud OpenSG destine a etre
// ajoute au graphe de scene. Sa position est mise a jour avec la methode
// setPosition(), avec laquelle on specifie le parcours et la position sur le
// parcours.
//
// Chaque wagon du train est represente par un objet de la classe Wagon. La
// methode init() cree le noeud OpenSG du wagon et est appelee pour chaque
// wagon par Train::init(). La position d'un wagon est mise a jour en donnant
// directement sa matrice de transformation a la methode setTransform().
//
////////////////////////////////////////////////////////////////////////////////


#ifndef TRAIN_H
#define TRAIN_H


#include <vector>
#include <OpenSG/OSGTransform.h>
#include "path.h"


class Wagon
{
	osg::TransformPtr	transform;

public:
	osg::NodePtr		init();
	void			setTransform(float matrix[16]);
};


class Train
{
	std::vector<Wagon>	wagons;

public:
	osg::NodePtr		init(unsigned int nbWagons);
	void			setPosition(Path &path, float walkingDistance);
};


#endif
